/* 
If someone besides Nick Sheets is reading, glancing, or laughing at this 
horrific example of game sourcecode, here are a few things you must know:

-The first line of code was written on Friday, August 10, 2007, 11:30 PM by
 Nicholas Vaughn (Blanko) Sheets.

-On the off chance you actually want to learn this code and do something with
 it, go ahead and do it. But, if I see Shambo II FOR SALE, I will hunt you down.
 A Shambo II for FREE, possibly with online (which I have no intention of doing)
 would be nice though.

-Each big function, such as one dealing with AI, has been dedicated to the 
 musical artist I was listening to at the time of its writing.


*************
Project officially scrapped and restarted Tuesday, June 10th, 2008, at 2:00AM.
*/

#include <hge.h>
#include <hgesprite.h>
#include <hgefont.h>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <list>
using namespace std;

HGE *hge = 0;

//Constants
const int WINDOW_LENGTH = 1024;
const int WINDOW_HEIGHT =  768;
const int SCREEN_LENGTH =  256;
const int SCREEN_HEIGHT =  192;
const int SCREEN_SCALE  =    4;
const int BOARD_X       =  SCREEN_LENGTH/2;
const int BOARD_Y       =  140;

//Textures
HTEXTURE t_clouds;
HTEXTURE t_sun;
HTEXTURE t_ground;
HTEXTURE t_sky;
HTEXTURE t_hge;
HTEXTURE t_pieces;
HTEXTURE t_board;
HTEXTURE t_select;
HTEXTURE t_combo;
HTEXTURE t_letterbox;
HTEXTURE t_smoke;

//Sprites
hgeSprite* s_clouds;
hgeSprite* s_sun;
hgeSprite* s_ground;
hgeSprite* s_sky;
hgeSprite* s_hge;
hgeSprite* s_board;
hgeSprite* s_letterbox;
hgeSprite* s_combo[4];
hgeSprite* s_select[2];
hgeSprite* s_smoke[6];

//Render Target
HTARGET    t_window_main;
hgeSprite* s_window_main;

//Fonts
hgeFont* font1;
hgeFont* font2;

//Prototypes
bool Menu();
bool Render_Menu();
bool Game();
bool Render_Game();

void inline Draw_All();                                                         //Draws the enlarged screen.
void inline Draw_Background();  
void inline Switch_Turn();                                                      //Switches game_turn and sets game_phase to 0.
bool inline Check_Full();                                                       //Is the board full?

bool Check_Surround(int square_a,int square_b);                                 //Is board square_b surrounding board square_a?
int  Check_Winner(int opp);                                                     //First checks for winner with combo; returns 1. Checks for all pieces; returns 2. Else, returns 0.
bool Check_Attack(int opp);                                                     //Searches whole game board to see if selected opponent can make an attack.

void Return_Pieces();                                                           //Scans whole board; returns pieces to proper owners' hands. Then calls Erase_Board(9);
void Reset_Match();                                                             //Calls Erase_Board(9); deletes and refills both hands.
void Erase_Board(int space);                                                    //If space = 9, whole board is erased. If not, deletes piece at board_array[space].

void Trans_Place();
void Trans_Attack();
void Trans_Winner();

void Human_Place();                                                             //Function detects keyhits for selecting hand piece, and board square. Switch_Turn() called and selection[1 & 2] reset.
void Human_Attack();                                                            //Function detects keyhits for selecting attacker and attackee. Sets animation = 1;
void CPU_Place();
void CPU_Attack();

void Update_Sun();
void Check_Messages();                                                          //Checks if message is 'dead'. If not, calls Update_Message();

//Classes


class Piece {
  private:
    hgeSprite* m_image;
    int m_type;  //0: Fire, 1: Earth, 2: Water
    int m_owner; //0: Player, 1: CPU
    int m_combo; //always starts at zero.
    int m_enemy; //What it's vunerable to.
  public:
    Piece(int type,int owner,int combo,float z);
    ~Piece();
    void Update_Piece();
    void Draw_Piece(float x,float y);
    int Get_Type();
    int Get_Owner();
    int Get_Combo();
    int Get_Enemy();
};


class Player {
  private:
    vector<Piece*> m_hand;
    bool m_human;
    int  m_points;
  public:
           Player(bool human);
          ~Player();
    void   Add_Piece(int type,int owner,int combo);
    void   Delete_Piece(int i);
    void   Delete_Hand();
    void   Draw_Hand(float x,float y);
    int    Get_HandSize();
    bool   Get_Human();
    Piece* Get_Piece(int i);
    int    Get_Points();
    void   Add_Point();
};


class Message {
  private:
    string m_msg;
    float  m_x;
    float  m_y;
    float  m_speed;
    float  m_life;
    int    m_lifespan;
  public:
          Message(string msg,float x,float y,float speed,int lifespan);
    void  Update_Message();
    void  Draw_Message();
    float Get_Life();
    int   Get_Lifespan();
};

/*class Effect {
  private:
    int */


//Globals - Yeah, yeah...fuck you.
Piece* board_array[9] = {0,0,0,0,0,0,0,0,0};



int    board_surround[9][4] = { {9,1,3,9},//0
                                {9,2,4,0},//1 //Nine is a "safe number"
                                {9,9,5,1},//2
                                {0,4,6,9},//3
                                {1,5,7,3},//4
                                {2,9,8,4},//5
                                {3,7,9,9},//6
                                {4,8,9,6},//7
                                {5,9,9,7} };//8

int        board_x[9] = {BOARD_X-16,BOARD_X+9,BOARD_X+34,
                         BOARD_X-25,BOARD_X  ,BOARD_X+25,
                         BOARD_X-34,BOARD_X-9,BOARD_X+16};

int        board_y[9] = {BOARD_Y-9,BOARD_Y-9,BOARD_Y-9,
                         BOARD_Y  ,BOARD_Y  ,BOARD_Y  ,
                         BOARD_Y+9,BOARD_Y+9,BOARD_Y+9};

float      board_z[9] = { 0.4,0.4,0.4,
                          0.3,0.3,0.3,
                          0.2,0.2,0.2 };

Player* opponent[2];

int game_turn;              //Whose Turn is it Anyway?
int game_phase     = 0;     //0: Placement, 1: Attack
int turn_phase     = 0;     //0: Select,    1: Place
int selection[2]   = {0,6}; /*Piece selection and Board selection 
                             OR Attacker and Target (with 9 as a safe number)*/

vector<Message*> message_bag;


int transition     = 0; //0-No transition; 1-Place; 2-Attack; 3-Win.
int trans_phase    = 0;
float  trans_timer = 0;
int trans_var[2]   = {0,0}; /* When transition = ...

                             1 - [0] is hand; [1] is board square.
                             2 - [0] is attacker; [1] is attackee.
                             3 - ?

                          */

                          
float sun_drift = .05;
float sun_x     = 182;
float sun_y     =  51;


int menu_screen = 0;
/*0 - Splash Screen
  1 - Main Menu
  2 - Newbie Talk
  3 - Options
  4 - Neato Note
  5 - Credits
  6-* Random Shit...*/


/*============================||
||            MENU            ||
||============================*/ 

bool Menu() {

    switch (hge->Input_GetKey()) {

      case HGEK_ENTER:
        if(menu_screen == 0) 
            menu_screen = 1; 
        break;
     
      case HGEK_N:
        if(menu_screen == 1) {

          opponent[0] = new Player(true);
          opponent[1] = new Player(true);
          Reset_Match();

          game_turn = hge->Random_Int(0,1);
  
          //message_bag.push_back( new Message("Let us play SHAMBO!",SCREEN_LENGTH/2,200,1,3) );

          hge->System_SetState(HGE_FRAMEFUNC,  Game);
          hge->System_SetState(HGE_RENDERFUNC, Render_Game); 
        }
        break;

      case HGEK_I:
        if (menu_screen == 1)
          menu_screen = 3;
        break;

      case HGEK_K:                                            
        if(menu_screen == 1)  
          menu_screen = 5;
        break;                                                    

      case HGEK_ESCAPE:
        if(menu_screen == 1 || menu_screen == 0) {
          return true;
        }else if (menu_screen != 1) {
          menu_screen = 1;
        }
        break;

    }   

    return false;
}

bool Render_Menu() { 

  hge->Gfx_BeginScene(t_window_main);
  hge->Gfx_Clear(0);

  switch (menu_screen) {

    case 0:

    font2->printf(SCREEN_LENGTH/2,10,HGETEXT_CENTER,           "Welcome to SHAMBO");
    font1->printf(SCREEN_LENGTH/2,30,HGETEXT_CENTER,    "A game of super strategy maybe.");
  
    font1->printf(20,60, HGETEXT_LEFT,                 "Game by   : Nick (Blanko) Sheets");
    font1->printf(20,70, HGETEXT_LEFT,                 "Version   : 0.7 - Cool Stuff    "); 
    font1->printf(20,80, HGETEXT_LEFT,                 "Completed : ---                 "); 

    font2->printf(SCREEN_LENGTH/2,110,HGETEXT_CENTER,          "Press the enter!"    );

    font1->printf(SCREEN_LENGTH/2,140,HGETEXT_CENTER,  "This game is freeware, yes. If you  ");
    font1->printf(SCREEN_LENGTH/2,150,HGETEXT_CENTER,  "purchased it, please contact seller,");
    font1->printf(SCREEN_LENGTH/2,160,HGETEXT_CENTER,  "on the head, with something heavy   ");
    font1->printf(SCREEN_LENGTH/2,170,HGETEXT_CENTER,  "and metal...                        ");  
    break;

    case 1:

    font2->printf(SCREEN_LENGTH/2,10,HGETEXT_CENTER,           "Welcome to MENU");
    font1->printf(SCREEN_LENGTH/2,30,HGETEXT_CENTER,    "A menu of cool strategy no.");  
    font1->printf(SCREEN_LENGTH/2,60,HGETEXT_CENTER,  "Press corresponding key for option");

    font1->printf(SCREEN_LENGTH/2,100,HGETEXT_CENTER,      "N - Start game please" );
    font1->printf(SCREEN_LENGTH/2,110,HGETEXT_CENTER,      "I - Go to the options" );
    font1->printf(SCREEN_LENGTH/2,120,HGETEXT_CENTER,      "C - Read a neato note" ); 
    font1->printf(SCREEN_LENGTH/2,130,HGETEXT_CENTER,      "K - Read them credits" );
    break;

    case 3:

    font2->printf(SCREEN_LENGTH/2,10,HGETEXT_CENTER,           "Welcome to OPTIONS");
    break;

    case 5:

    font2->printf(SCREEN_LENGTH/2,20,HGETEXT_CENTER,                  "Them Credits"              );
    font1->printf(SCREEN_LENGTH/2,40,HGETEXT_CENTER,       "GC Atari 2600 font -   Zeh Fernando\n"
                                                           "Freesound.org SFX  - NoiseCollector\n"
                                                           "Haff's Game Engine -   Relish Games\n"
                                                           "Everything else    - Nick V. Sheets\n"
                                                                   "    Thanks Everyone\n"         
                                                                   "A Tea-Fueled Production"      );   

                                                             s_hge->Render(SCREEN_LENGTH/2,140);
    font1->printf(SCREEN_LENGTH/2,170,HGETEXT_CENTER,               "hge.relishgames.com"         );
    font1->printf( 2,182,HGETEXT_LEFT,                     "Back-ESC"                             );
    break;
     
  }

  hge->Gfx_EndScene();

  Draw_All();


  return false;
}

/*============================||
||            GAME            ||
||============================*/

bool Game() {

  Update_Sun();

  if (message_bag.size() == 0 && transition == 0) {

    if (game_phase == 0) {

      if (Check_Full()) {
        message_bag.push_back( new Message("Fightin' time!",SCREEN_LENGTH/2,200,1,3) );

        game_phase = 1;
        selection[0] = 6;
        selection[1] = 9;

     
      } else {

        if (opponent[game_turn]->Get_HandSize() == 0) {
          message_bag.push_back( new Message("Player has nothing left!",SCREEN_LENGTH/2,200,1,3) );

          Switch_Turn();
          selection[0] = 0;
          selection[1] = 6;

        } else {


                  if (opponent[game_turn]->Get_Human() == true)  {             
                    Human_Place();
                  } else {
                    //CPU_Place();
                  }

        }

      }

    } else {

      if (Check_Attack(0) == false && Check_Attack(1) == false) {

        message_bag.push_back( new Message("Stand-off!",SCREEN_LENGTH/2,200,1,3) );

        if (Check_Full()) { Return_Pieces(); Switch_Turn(); }

        game_phase = 0;
        selection[0] = 0;
        selection[1] = 6;

      } else {

        if (Check_Attack(game_turn) == false) {

          message_bag.push_back( new Message("Player can't attack.",SCREEN_LENGTH/2,200,1,3) );

          Switch_Turn();
          selection[0] = 6;
          selection[1] = 9;

        } else {


                  if (opponent[game_turn]->Get_Human() == true)  {             
                    Human_Attack();
                  } else {
                    //CPU_Attack();
                  }

        }

      }

    }

    if ( Check_Winner(0) == 1)  message_bag.push_back( new Message("Solids with full combo!",SCREEN_LENGTH/2,200,1,3) );
    if ( Check_Winner(0) == 2)  message_bag.push_back( new Message("Solids with all pieces!",SCREEN_LENGTH/2,200,1,3) ); 
    if ( Check_Winner(1) == 1) message_bag.push_back( new Message("Stripes with full combo!",SCREEN_LENGTH/2,200,1,3) );
    if ( Check_Winner(1) == 2) message_bag.push_back( new Message("Stripes with all pieces!",SCREEN_LENGTH/2,200,1,3) ); 

  }  



  if (transition != 0) {

    if (hge->Timer_GetTime() >= trans_timer + 1) {
      ++trans_phase;
      trans_timer = hge->Timer_GetTime();
    }


    if (transition == 1) {
      Trans_Place();
    } else
    if (transition == 2) {
      Trans_Attack();
    }


  }
     


  if (message_bag.size() != 0 && transition == 0) {
    Check_Messages();
  } 



  if (hge->Input_GetKey() == HGEK_ESCAPE)
    return true;
  return false;
}


bool Render_Game() { 


  hge->Gfx_BeginScene(t_window_main);
  hge->Gfx_Clear(0);

  Draw_Background(); 

  if (message_bag.size() == 0 && transition == 0) {

      font1->printf(20,90,HGETEXT_LEFT, "SLD: %i",opponent[0]->Get_Points());
      font1->printf(20,100,HGETEXT_LEFT,"STR: %i",opponent[1]->Get_Points());

      if (game_phase == 0) { 
      s_select[0]->Render(20+15*selection[0],187);
      if(turn_phase == 1)  s_select[1]->Render(board_x[selection[1]],board_y[selection[1]]); }

      if (game_phase == 1) {
      if(selection[0] != 9)  s_select[1]->Render(board_x[selection[0]],board_y[selection[0]]);
      if(selection[1] != 9)  s_select[1]->Render(board_x[selection[1]],board_y[selection[1]]); }
  } 



  if (message_bag.size() != 0 && transition == 0) {

       for(int i=0;i<message_bag.size();++i)
       message_bag[i]->Draw_Message();
  }



  if (transition == 0) {

      for(int i=0;i<9;++i) {
      if (board_array[i] != 0) board_array[i]->Draw_Piece(board_x[i],board_y[i]); }

      opponent[game_turn]->Draw_Hand(20,185);
      //opponent[1]->Draw_Hand(20,165);
  }



  if (transition == 1) {

    for(int i=0;i<9;++i) {
    if (board_array[i] != 0) board_array[i]->Draw_Piece(board_x[i],board_y[i]); }

    if (trans_phase < 2) {
      opponent[game_turn]->Get_Piece(trans_var[0])->Draw_Piece(20,185);
    }

    if (trans_phase >= 2) {
      board_array[trans_var[1]]->Draw_Piece(board_x[trans_var[1]],board_y[trans_var[1]]);
    }

  }


  
  if (transition == 2) {
    
    if (trans_phase < 2) {
      board_array[trans_var[0]]->Draw_Piece(board_x[trans_var[0]],board_y[trans_var[0]]);
      board_array[trans_var[1]]->Draw_Piece(board_x[trans_var[1]],board_y[trans_var[1]]);
    }

    if (trans_phase >= 2 && trans_phase < 4) {
      board_array[trans_var[0]]->Draw_Piece(board_x[trans_var[0]],board_y[trans_var[0]]);
    }

    if (trans_phase >= 4) {
      board_array[trans_var[1]]->Draw_Piece(board_x[trans_var[1]],board_y[trans_var[1]]);
    }

  }



  hge->Gfx_EndScene();


  Draw_All();

  return false;
}



int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int) {
  hge = hgeCreate(HGE_VERSION);

  hge->System_SetState(HGE_FRAMEFUNC,     Menu);
  hge->System_SetState(HGE_RENDERFUNC,    Render_Menu);
  hge->System_SetState(HGE_SCREENWIDTH,   WINDOW_LENGTH);
  hge->System_SetState(HGE_SCREENHEIGHT,  WINDOW_HEIGHT);
  hge->System_SetState(HGE_FPS,           HGEFPS_VSYNC);
  hge->System_SetState(HGE_SHOWSPLASH,    false);
  hge->System_SetState(HGE_TEXTUREFILTER, false);
  hge->System_SetState(HGE_WINDOWED,      true);
  hge->System_SetState(HGE_USESOUND,      false);
  hge->System_SetState(HGE_ZBUFFER,       true);
  hge->System_SetState(HGE_HIDEMOUSE,     false); 
 
  if( hge->System_Initiate() ) {

    font1 = new hgeFont("Fonts/font1.fnt");   
    font1 ->SetColor(ARGB(255,236,236,236));
    font1 ->SetZ(0);
    font2 = new hgeFont("Fonts/font2.fnt");
    font2 ->SetColor(ARGB(255,224,236,156));
    font2 ->SetZ(0);

    t_window_main = hge->Target_Create(SCREEN_LENGTH,SCREEN_HEIGHT,true);
    s_window_main = new hgeSprite(hge->Target_GetTexture(t_window_main),0,0,SCREEN_LENGTH,SCREEN_HEIGHT);


    t_clouds    = hge->Texture_Load("Images/Background/SHMB_clouds.png");
    t_ground    = hge->Texture_Load("Images/Background/SHMB_ground.png");
    t_sky       = hge->Texture_Load("Images/Background/SHMB_sky.png");
    t_sun       = hge->Texture_Load("Images/Background/SHMB_sun.png");
    t_hge       = hge->Texture_Load("Images/SHMB_hge.png");
    t_pieces    = hge->Texture_Load("Images/Pieces/SHMB_pieces.png");
    t_board     = hge->Texture_Load("Images/SHMB_board.png");
    t_select    = hge->Texture_Load("Images/SHMB_select.png");
    t_combo     = hge->Texture_Load("Images/Pieces/SHMB_combo.png");
    t_letterbox = hge->Texture_Load("Images/Background/SHMB_letterbox.png");
    t_smoke     = hge->Texture_Load("Images/SHMB_smoke.png");

    s_clouds    = new hgeSprite(t_clouds,0,0,256,75);
    s_ground    = new hgeSprite(t_ground,0,0,256,76);
    s_sky       = new hgeSprite(t_sky,0,0,256,192);
    s_letterbox = new hgeSprite(t_letterbox,0,0,256,192);
    s_sun       = new hgeSprite(t_sun,0,0,58,58);        
    s_hge       = new hgeSprite(t_hge,0,0,58,42);        
    s_board     = new hgeSprite(t_board,0,0,103,28);  
    s_select[0] = new hgeSprite(t_select,0,0,16,24); 
    s_select[1] = new hgeSprite(t_select,16,0,35,10);

    for(int i=0;i<4;++i) {
    s_combo[i]  = new hgeSprite(t_combo,10*i,0,10,3);
    s_combo[i]  ->SetZ(.1);
    }

    for(int i=0;i<6;++i) {
    s_smoke[i] = new hgeSprite(t_smoke,24*i,0,24,40);
    s_smoke[i] ->SetHotSpot(12,40);
    }

    s_sun      ->SetHotSpot(29,29);
    s_hge      ->SetHotSpot(29,21);
    s_board    ->SetHotSpot(50,16);
    s_select[0]->SetHotSpot(8,24);
    s_select[1]->SetHotSpot(16,7);

    s_clouds    ->SetZ(1);   
    s_ground    ->SetZ(1);
    s_sky       ->SetZ(1);
    s_sun       ->SetZ(1); 
    s_board     ->SetZ(1); 
    s_letterbox ->SetZ(0);

    hge->System_Start();
  }


  //Delete

  delete font1;
  delete font2;

  delete opponent[0];
  delete opponent[1];

  for(int i=0;i<9;++i)
  delete board_array[i];

  delete s_clouds;
  delete s_sun;
  delete s_ground;
  delete s_sky;
  delete s_hge;
  delete s_board;
  delete s_combo[0]; delete s_combo[1]; delete s_combo[2]; delete s_combo[3];
  delete s_select[0]; delete s_select[1];

  hge->Texture_Free(t_clouds);
  hge->Texture_Free(t_sun);
  hge->Texture_Free(t_ground);
  hge->Texture_Free(t_sky);
  hge->Texture_Free(t_hge);
  hge->Texture_Free(t_pieces);
  hge->Texture_Free(t_board);
  hge->Texture_Free(t_select);
  hge->Texture_Free(t_combo);

  hge->System_Shutdown();
  hge->Release();
  return 0;
}


/*============================||
||          FUNCTIONS         ||
||============================*/

//======================================\\
//======================================\\
//===============MISC...================\\
//======================================\\
//======================================\\

void inline Draw_All() 

    {
        hge->Gfx_BeginScene();
        hge->Gfx_Clear(0);
          s_window_main->RenderEx(0,0,0,SCREEN_SCALE,SCREEN_SCALE);
        hge->Gfx_EndScene();
    }



void inline Draw_Background() 

    {
        s_sky   ->Render(0,0);    
        s_sun   ->Render(sun_x,sun_y); 
        s_clouds->Render(0,6);   
        s_ground->Render(0,116);
        s_board ->Render(SCREEN_LENGTH/2,140);
    }


void inline Switch_Turn() 

    {
        turn_phase = 0;

        if (game_turn == 0) 
        {
            game_turn = 1;
        }else{
            game_turn = 0;
        }

    }


bool inline Check_Full() 

    {
        for (int i=0;i<9;++i) {
          if (board_array[i] == 0)
          return false;
        }

        return true;
    }



//======================================\\
//======================================\\
//============BOARD CHECKS...===========\\
//======================================\\
//======================================\\


bool Check_Surround(int square_a,int square_b) 

    {

        for(int i=0;i<4;++i) {
            if (board_surround[square_a][i] == square_b)
            return true;
        }

        return false;

    }



int Check_Winner(int opp) 

    {
  
        int num_pieces = 0;

        for (int i=0;i<9;++i) {
          if (board_array[i] != 0) {
            if (board_array[i]->Get_Owner() == opp) {   
            
                ++num_pieces;

              if (board_array[i]->Get_Combo() == 4) {

                opponent[opp]->Add_Point();
                Reset_Match();
          
                return 1;
                //message_bag.push_back( new Message("Winner by full combo!",SCREEN_LENGTH/2,200,1,3) );


              }


            }
          }
        }

        if(opponent[opp]->Get_HandSize() == (12-num_pieces)) {

          opponent[opp]->Add_Point();
          Reset_Match();

          return 2;
          //message_bag.push_back( new Message("Winner with all pieces!",SCREEN_LENGTH/2,200,1,3) );

  
        }

        return 0;

    }

  
bool Check_Attack(int opp) 

    {

      for (int i=0;i<9;++i) {
          if (board_array[i] != 0) {
          if (board_array[i]->Get_Owner() == opp) {

            for (int j=0;j<4;++j) {
  
                if (board_surround[i][j] != 9 && board_array[board_surround[i][j]] != 0) {
                if (board_array[board_surround[i][j]]->Get_Owner() != opp) {
                if (board_array[board_surround[i][j]]->Get_Enemy() == board_array[i]->Get_Type()) {
  
                    return true;

                }
                }
                }
            }       //IT'S A MOTHER FUCKING MASTERPIECE!
          }
          }
      }
      return false; 
        
    }


//======================================\\
//======================================\\
//===========BOARD ACTIONS...===========\\
//======================================\\
//======================================\\


void Return_Pieces() {

    for(int i=0;i<9;++i) {
    if (board_array[i] != 0)
    opponent[board_array[i]->Get_Owner()]->Add_Piece(board_array[i]->Get_Type(),
                                                     board_array[i]->Get_Owner(),
                                                     board_array[i]->Get_Combo());
    }

    Erase_Board(9);

}

void Reset_Match() {

  Erase_Board(9);

  opponent[0]->Delete_Hand();
            opponent[0]->Add_Piece(0,0,0);
            opponent[0]->Add_Piece(0,0,0);
            opponent[0]->Add_Piece(1,0,0);
            opponent[0]->Add_Piece(1,0,0);
            opponent[0]->Add_Piece(2,0,0);
            opponent[0]->Add_Piece(2,0,0);
  opponent[1]->Delete_Hand();
            opponent[1]->Add_Piece(0,1,0);
            opponent[1]->Add_Piece(0,1,0);
            opponent[1]->Add_Piece(1,1,0);
            opponent[1]->Add_Piece(1,1,0);
            opponent[1]->Add_Piece(2,1,0);
            opponent[1]->Add_Piece(2,1,0);

  game_phase   = 0;
}


void Erase_Board(int space) { //If 9, clear all.

  if (space == 9) {
    
      for (int i=0;i<9;++i) {
              delete board_array[i];
              board_array[i]    = 0;        
      }

  }else{

    delete board_array[space];
    board_array[space]    = 0;

  }

}


void Attack_Algorithm(int square1,int square2) {

  opponent[game_turn]->Add_Piece(board_array[square2]->Get_Type(),game_turn,board_array[square2]->Get_Combo()); 
    Erase_Board(square2);                                                                                              
  board_array[square2] = new Piece(board_array[square1]->Get_Type(),
                                                          game_turn,
                                board_array[square1]->Get_Combo()+1,
                                                   board_z[square2] );
    Erase_Board(square1);     
}

//======================================\\
//======================================\\
//============TRANSITIONS...============\\
//======================================\\
//======================================\\

void Trans_Place() {

  if (trans_phase == 2) {

    board_array[trans_var[1]] = new Piece((opponent[game_turn]->Get_Piece(trans_var[0]))->Get_Type(),
                                          (opponent[game_turn]->Get_Piece(trans_var[0]))->Get_Owner(),
                                          (opponent[game_turn]->Get_Piece(trans_var[0]))->Get_Combo(),
                                          board_z[trans_var[1]]);

    opponent[game_turn]->Delete_Piece(trans_var[0]);
    ++trans_phase;
  }  


  if (trans_phase == 4) {
    transition  = 0;
    trans_phase = 0;
    trans_timer = 0;
    Switch_Turn();
  }

}

void Trans_Attack() { 

  if (trans_phase == 2) {

    opponent[game_turn]->Add_Piece(board_array[trans_var[1]]->Get_Type(),game_turn,board_array[trans_var[1]]->Get_Combo()); 
    Erase_Board(trans_var[1]);
    ++trans_phase;

  }

  if (trans_phase == 4) {

    board_array[trans_var[1]] = new Piece(board_array[trans_var[0]]->Get_Type(),game_turn,board_array[trans_var[0]]->Get_Combo()+1,board_z[trans_var[1]] );
    Erase_Board(trans_var[0]); 
    ++trans_phase;

  }

  if (trans_phase == 6) { 
    transition  = 0;
    trans_phase = 0;
    trans_timer = 0;
    Switch_Turn();
  }

}


//======================================\\
//======================================\\
//=========OPPONENT ACTIONS...==========\\
//======================================\\
//======================================\\

void Human_Place() {

  switch(hge->Input_GetKey()) {
            
      case HGEK_LEFT:     

          if (selection[turn_phase] > 0)  selection[turn_phase] -= 1;
          break;

      case HGEK_RIGHT: 
   
          if (turn_phase == 0) {                 
                if (selection[0] < opponent[game_turn]->Get_HandSize()-1 )  selection[0] += 1;
          } else {
                if (selection[1] < 8)  selection[1] += 1;
          }
          break;

      case HGEK_UP:   
   
          if (turn_phase == 1) {                            
                if (selection[1]-3 >= 0)  selection[1] -= 3;
          }
          break;
  
      case HGEK_DOWN: 
     
          if (turn_phase == 1) {                          
                if (selection[1]+3 < 9 )  selection[1] += 3;
          }
          break;

      case HGEK_SPACE:

          if (turn_phase == 0) {
                turn_phase = 1;
 
          } else {

                if (board_array[selection[1]] == 0) {

                    transition = 1;
                    trans_var[0] = selection[0];
                    trans_var[1] = selection[1]; 

                    selection[0] = 0;
                    selection[1] = 6;
                }
          }
          break;

      case HGEK_BACKSPACE:

          turn_phase = 0;
          break;
  }

}


void Human_Attack() {

  switch(hge->Input_GetKey()) {

      case HGEK_LEFT:
                          
        if (selection[turn_phase] > 0)
          selection[turn_phase] -= 1;
        break;

      case HGEK_RIGHT:
                 
        if (selection[turn_phase] < 8)
          selection[turn_phase] += 1;
        break;

      case HGEK_UP:
                                 
        if (selection[turn_phase]-3 >= 0)
          selection[turn_phase] -= 3;
        break;
  
      case HGEK_DOWN:
                              
        if (selection[turn_phase]+3 < 9)
          selection[turn_phase] += 3;
        break;

      case HGEK_BACKSPACE:

        if (turn_phase == 1) {
          selection[1] = 9;
          turn_phase   = 0;
        }
        break;
          

      case HGEK_SPACE:
    
        if (turn_phase == 0) {
            if (board_array[selection[0]] != 0) {
            if (board_array[selection[0]]->Get_Owner() == game_turn) {
              turn_phase   = 1;
              selection[1] = selection[0];
            }
            }

        } else 

        if (turn_phase == 1) {
              if (board_array[selection[1]] != 0) {
              if (board_array[selection[1]]->Get_Owner() != game_turn) {
              if (Check_Surround(selection[0],selection[1]) == true) {
              if (board_array[selection[1]]->Get_Enemy() == board_array[selection[0]]->Get_Type()) {
    
                    transition = 2;
                    trans_var[0] = selection[0];
                    trans_var[1] = selection[1]; 

                  selection[0] = 6;
                  selection[1] = 9;

              }
              }
              }
              }
        }
        break;
  } 

}

/*void CPU_Place() {
  
  int rand_piece = hge->Random_Int(0,opponent[game_turn]->Get_HandSize() - 1);

  for(int i=0;i<9;++i) {

    if(board_array[i] == 0) {
      Place_Algorithm(rand_piece,i);
      break;
    } 
  }
}

void CPU_Attack() {
  
  bool attacked = false;

  for(int i=0;i<9;++i) {

              if (attacked == false) {
              if (board_array[i] != 0) {
              if (board_array[i]->Get_Owner() == game_turn) {
              
                    for(int j=0;j<4;++j) {
                      if (board_surround[i][j] != 9 && board_array[board_surround[i][j]] != 0) {
                      if (board_array[board_surround[i][j]]->Get_Owner() != game_turn) {
                      if (board_array[board_surround[i][j]]->Get_Enemy() == board_array[i]->Get_Type()) {

                        Attack_Algorithm(i,board_surround[i][j]);

                        attacked = true;
                        break;
                      }
                      }
                      }
                    }

              }
              }
              }
  }

}*/
      

//======================================\\
//======================================\\
//===============EXTRAS...==============\\
//======================================\\
//======================================\\

void Update_Sun() {

  sun_x += (sun_drift);
  if (sun_x >= 182+3 || sun_x <= 182-3)
          sun_drift = -sun_drift;

}

void Check_Messages() {

  for(int i=0;i<message_bag.size();++i) {    

      if (hge->Timer_GetTime() >= message_bag[i]->Get_Life() + message_bag[i]->Get_Lifespan() ) {
        delete message_bag[i];
        message_bag.erase(message_bag.begin() + i);
        i -= 1;
      } else {  
        message_bag[i]->Update_Message();
      }
  }

}


//======================================\\
//======================================\\
//==============CLASSES...==============\\
//======================================\\
//======================================\\

/*============================||
||        PIECE CLASS         ||
||============================*/

Piece::Piece(int type,int owner,int combo,float z) {


  m_image = new hgeSprite(t_pieces,12*type,20*owner,12,20);
  m_image ->SetHotSpot(6,20);
  m_image ->SetZ(z);

  m_type  = type;
  m_owner = owner;
  m_combo = combo;
  
  if (type == 0) 
      m_enemy = 2;
  if (type == 1) 
      m_enemy = 0;
  if (type == 2)
      m_enemy = 1;

}

Piece::~Piece() {
  delete m_image;
}
  
void Piece::Draw_Piece(float x,float y) {
  m_image->Render(x,y);

  if (m_combo != 0)
    s_combo[m_combo-1]->Render(x-5,y-20);
}

int Piece::Get_Type()  { return m_type;  }
int Piece::Get_Owner() { return m_owner; }
int Piece::Get_Combo() { return m_combo; }
int Piece::Get_Enemy() { return m_enemy; }

/*============================||
||        PLAYER CLASS        ||
||============================*/

Player::Player(bool human) {
  m_human  = human;
  m_points = 0;
}

Player::~Player() {

  for(int i=0;i<m_hand.size();++i)
  delete m_hand[i];

  m_hand.clear();

}

void Player::Add_Piece(int type,int owner,int combo) {
  m_hand.push_back( new Piece(type,owner,combo,.1) );
}

void Player::Delete_Piece(int i) {
  delete m_hand[i];
  m_hand.erase(m_hand.begin() + i);
}

void Player::Delete_Hand() {

  for (int i=0;i<m_hand.size();++i)
    delete m_hand[i];

  m_hand.clear();

}

void Player::Draw_Hand(float x,float y) {  
  for (int i=0;i<m_hand.size();++i) 
  m_hand[i]->Draw_Piece(x+i*15,y);
}

void Player::Add_Point() { ++m_points; }

int    Player::Get_HandSize()      { return m_hand.size(); }
Piece* Player::Get_Piece(int i)    { return m_hand[i];     }
bool   Player::Get_Human()         { return m_human;       }
int    Player::Get_Points()        { return m_points;      }

/*============================||
||       MESSAGE CLASS        ||
||============================*/

Message::Message(string msg,float x,float y,float speed,int lifespan) {
  m_msg       = msg;
  m_x         = x;
  m_y         = y;
  m_speed     = speed;
  m_lifespan  = lifespan;
  m_life      = hge->Timer_GetTime();
}


void Message::Update_Message() {

    if (m_y > 90) {
      m_y -= (m_speed);
    } else {
      m_y  = 90;
    }

}


void Message::Draw_Message() {
  font2->printf(m_x,m_y,HGETEXT_CENTER,"%s",m_msg.c_str());

}


float Message::Get_Life()     { return m_life;     }
int   Message::Get_Lifespan() { return m_lifespan; }




      

  
  
